/*  Bonnie Berger, David Wilson and Theodore Tonchev 1992  */
/*      C Header File: modified Ethan Wolf 1995      */
/*  scconst.h contains constants used throughout the program and for  */
/*  defining array sizes.                                             */
#include "options.h"   /* Need this since use ifdef COMPUTE_GAUSSIAN_VERSION */

#ifndef __scconst_h__
#define __scconst_h__ 1


#define Pi 3.1415927

/*  HUGE_VAL should be defined in math.h.  This value here is a different */
/*  value. */

/*
#ifndef HUGE_VAL 
#define HUGE_VAL 32767
#endif 
*/

#define DEFOFFSET  3
/*  Default value for functnum = number of pair distances to use.  */ 
#define DEFAULT_FUNCTNUM    3

/* Table Calc Constants */
#define LOG0VAL    -2800

/* Window sizes in scscore.c  determine how big a window to consider. */

#define STOCKWINDOW    28
#define PAIRWINDOW     30
#define MINWINDOW 28

extern int WINDOW;

/** For giving 0 frequency events a non-zero estimated prob. **/
#define DEFAULT_SCALE0 3

extern double SCALE0;

#define AANUM      20

/* #define AnyRes  AANUM */
#define POSNUM     7
#define MAXLINE    1040
#define MAXSEQLEN  8000
#define MAXFUNCTNUM 7
#define MAXNUMCOILS 120

/* General Constants */

#ifdef SMALL_MEMORY
  #define MAX_NUM_SCORE_DIM 6
#else
  #define MAX_NUM_SCORE_DIM 14
#endif

#define NUM_DIM_IN_ORIG_MATRIX 14

#define NUMBER_TABLES 2
#define MAX_TABLE_NUMBER 2   /* Same as NUMBER_TABLES. **/
#define MAX_CLASS_NUMBER 3
#define NUMBER_CLASSES 3

/** This stuff is used when trying to choose optimal init_prob of di/trimers */
#define GRID_SIZE_DIMER 30
#define GRID_SIZE_TRIMER 30
#define DIMER_GRID_STEP .0015 
#define TRIMER_GRID_STEP .001
#define MIN_DIMER_PROB 0
#define MIN_TRIMER_PROB 0

#define MIN(A,B) ((A)<(B)?(A):(B))
#define MAX(A,B) ((A)>(B)?(A):(B))

/* The residues in the order that the tables use, the order that Stock used. */
enum { Leucine,
       Isoleucine,
       Valine,
       Methionine,
       Phenylalanine,
       Tyrosine,
       Glycine,
       Alanine,
       Lysine,
       Arginine,
       Histidine,
       GlutamicAcid,
       AsparticAcid,
       Glutamine,
       Asparagine,
       Serine,
       Threonine,
       Cysteine,
       Tryptophan,
       Proline,
       AnyRes,
       Glutamix,
       Asparagix,
       Undefined
     };

#define NUM_RES_TYPE Undefined

#endif   /* __scconst_h__ */


/*       End of Code       */


