package Pairwise;

use 5.008;
use strict;
use warnings;

use base qw(Exporter);

our @EXPORT_OK = qw(pairwise);
our $VERSION = '0.01';

require XSLoader;
XSLoader::load('Pairwise', $VERSION);

1;
__END__

=head1 NAME

Pairwise - Perl extension for doing pairwise comparisons of sequences

=head1 SYNOPSIS

  use Pairwise qw(pairwise);
  open my $fh "fasta_file" or die $!;

  my ($number, @distances) = pairwise $fh;
  my @ids = splice 0, $number, @distances;

=head1 ABSTRACT

Gives various C based methods for pairwise comparison and identity scores between two sequences.

=head1 DESCRIPTION

This module implements a C based pairwise comparison algorithim for biological sequences. Gaps in the input sequences should be represented as "-" characters. The sequences should be in FASTA format.

=head2 EXPORT

None by default.

=head1 SEE ALSO

http://www.compbio.dundee.ac.uk

=head1 AUTHOR

Jonathan Barber <jon@compbio.dundee.ac.uk>

=head1 COPYRIGHT AND LICENSE

Copyright 2003 by Jonathan Barber <jon@compbio.dundee.ac.uk>

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself.

=cut
